<template>
  <div style="padding: 20px; padding-top: 0" class="reporttablecardxm">
    <div
      style="position: absolute; padding-top: 10px; line-height: 32px"
      class="header_sd-header_common"
    >
      <div :class="$style.titlepoint"></div>
      <span :class="['toptitle', $style.toptitle]">审计分类问题数量分布</span>
    </div>
    <sd-data-table
      ref="dataTable"
      :columns="columns"
      :projectlist="true"
      :data-url="dataUrl"
      :actions="actions"
      :process-req="processReq"
      :process-res="processRes"
      :defultpagination-pagesize="50"
    />
  </div>
</template>

<script>
import { Message } from 'ant-design-vue'
import TableActionTypes from '@/common/services/table-action-types'
import download from '@/common/services/download'
import auditService from './iam-audit-dsc-service'
import components from './_import-components/spic-audit-dsc-topfive-list-import'

export default {
  name: 'SpicAuditDscTopfiveList',
  metaInfo: {
    title: '审计分类问题数量分布',
  },
  components,
  data() {
    return {
      year1: '2023',
      params: null,
      columns: [],
      year: '',
      data: [],
      actions: [
        {
          label: '导出',
          id: 'export',
          permission: null,
          type: TableActionTypes.primary,
          callback: () => {
            const params = JSON.parse(this.$route.query.params)
            if (this.$route.query.type === 'top5list') {
              auditService
                .exportTop5List(params)
                .then((data) => {
                  const url = URL.createObjectURL(data)
                  download(url, '审计分类问题数量分布列表导出.xls')
                })
                .catch(() => {
                  Message.error('导出失败')
                })
            }
          },
        },
      ],
    }
  },
  computed: {
    dataUrl() {
      return 'api/xcoa-mobile/v1/spicDecisionSupportCenter/getTopCategoryList'
    },
  },
  mounted() {
    const year = this.$route.query.year
    this.columns.push({ title: '一级分类名称', dataIndex: '' })
    this.columns.push({ title: '二级分类名称', dataIndex: '' })
    this.columns.push({ title: year - 3, dataIndex: '' })
    this.columns.push({ title: year - 2, dataIndex: '' })
    this.columns.push({ title: year - 1, dataIndex: '' })
    this.columns.push({ title: year, dataIndex: '' })
  },
  methods: {
    processRes(res) {
      return res
    },
    processReq(req) {
      const params = JSON.parse(this.$route.query.params)
      req.data = {
        ...req.data,
        ...params,
      }
      if (req.data.pageIndex === undefined) {
        req.data.pageIndex = req.data.startPosition
      }

      if (req.data.pageSize === undefined) {
        req.data.pageSize = 10
      }
      return req
    },
  },
}
</script>

<style module lang="scss">
@use '@/common/design' as *;
.titlepoint {
  position: absolute;
  top: 12px;
  left: 20px;
  width: 8px;
  height: 27px;
  background: #1890ff;
  border-radius: 8px;
}
.toptitle {
  position: absolute;
  top: 9px;
  left: 40px;
  width: 250px;
  font-size: 22px;
  font-weight: bold;
  color: #404040;
}
</style>
